diff --git a/libavfilter/Makefile b/libavfilter/Makefile
index 8031f59af5..d12f7dc3a5 100644
--- a/libavfilter/Makefile
+++ b/libavfilter/Makefile
@@ -60,6 +60,7 @@ OBJS-$(CONFIG_AGATE_FILTER)                  += af_agate.o
 OBJS-$(CONFIG_AIIR_FILTER)                   += af_aiir.o
 OBJS-$(CONFIG_AINTEGRAL_FILTER)              += af_aderivative.o
 OBJS-$(CONFIG_AINTERLEAVE_FILTER)            += f_interleave.o
+OBJS-$(CONFIG_ALATENCY_FILTER)               += f_latency.o
 OBJS-$(CONFIG_ALIMITER_FILTER)               += af_alimiter.o
 OBJS-$(CONFIG_ALLPASS_FILTER)                += af_biquads.o
 OBJS-$(CONFIG_ALOOP_FILTER)                  += f_loop.o
@@ -317,6 +318,7 @@ OBJS-$(CONFIG_INTERLEAVE_FILTER)             += f_interleave.o
 OBJS-$(CONFIG_KERNDEINT_FILTER)              += vf_kerndeint.o
 OBJS-$(CONFIG_KIRSCH_FILTER)                 += vf_convolution.o
 OBJS-$(CONFIG_LAGFUN_FILTER)                 += vf_lagfun.o
+OBJS-$(CONFIG_LATENCY_FILTER)                += f_latency.o
 OBJS-$(CONFIG_LENSCORRECTION_FILTER)         += vf_lenscorrection.o
 OBJS-$(CONFIG_LENSFUN_FILTER)                += vf_lensfun.o
 OBJS-$(CONFIG_LIBVMAF_FILTER)                += vf_libvmaf.o framesync.o
diff --git a/libavfilter/allfilters.c b/libavfilter/allfilters.c
index e1e43726b5..e809d3b7c4 100644
--- a/libavfilter/allfilters.c
+++ b/libavfilter/allfilters.c
@@ -53,6 +53,7 @@ extern const AVFilter ff_af_agate;
 extern const AVFilter ff_af_aiir;
 extern const AVFilter ff_af_aintegral;
 extern const AVFilter ff_af_ainterleave;
+extern const AVFilter ff_af_alatency;
 extern const AVFilter ff_af_alimiter;
 extern const AVFilter ff_af_allpass;
 extern const AVFilter ff_af_aloop;
@@ -302,6 +303,7 @@ extern const AVFilter ff_vf_interleave;
 extern const AVFilter ff_vf_kerndeint;
 extern const AVFilter ff_vf_kirsch;
 extern const AVFilter ff_vf_lagfun;
+extern const AVFilter ff_vf_latency;
 extern const AVFilter ff_vf_lenscorrection;
 extern const AVFilter ff_vf_lensfun;
 extern const AVFilter ff_vf_libvmaf;
diff --git a/libavfilter/f_latency.c b/libavfilter/f_latency.c
new file mode 100644
index 0000000000..324040922f
--- /dev/null
+++ b/libavfilter/f_latency.c
@@ -0,0 +1,171 @@
+/*
+ * Copyright (c) 2021 Paul B Mahol
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "libavutil/opt.h"
+#include "avfilter.h"
+#include "filters.h"
+#include "formats.h"
+#include "internal.h"
+
+typedef struct LatencyContext {
+    const AVClass *class;
+
+    int64_t min_latency;
+    int64_t max_latency;
+    int64_t sum;
+} LatencyContext;
+
+#define OFFSET(x) offsetof(LatencyContext, x)
+#define VF AV_OPT_FLAG_VIDEO_PARAM|AV_OPT_FLAG_FILTERING_PARAM
+
+static const AVOption latency_options[] = {
+    { NULL }
+};
+
+static av_cold int init(AVFilterContext *ctx)
+{
+    LatencyContext *s = ctx->priv;
+
+    s->min_latency = INT64_MAX;
+    s->max_latency = INT64_MIN;
+
+    return 0;
+}
+
+static int activate(AVFilterContext *ctx)
+{
+    LatencyContext *s = ctx->priv;
+    AVFilterLink *inlink = ctx->inputs[0];
+    AVFilterLink *outlink = ctx->outputs[0];
+
+    FF_FILTER_FORWARD_STATUS_BACK(outlink, inlink);
+
+    if (ctx->inputs[0]->src &&
+        ctx->inputs[0]->src->nb_inputs > 0) {
+        AVFilterLink *prevlink = ctx->inputs[0]->src->inputs[0];
+        int64_t delta = 0;
+
+        switch (prevlink->type) {
+        case AVMEDIA_TYPE_AUDIO:
+            delta = prevlink->sample_count_in - inlink->sample_count_out;
+            break;
+        case AVMEDIA_TYPE_VIDEO:
+            delta = prevlink->frame_count_in - inlink->frame_count_out;
+            break;
+        }
+
+        if (delta > 0) {
+            s->min_latency = FFMIN(s->min_latency, delta);
+            s->max_latency = FFMAX(s->max_latency, delta);
+        }
+    }
+
+    if (ff_inlink_queued_frames(inlink)) {
+        AVFrame *frame = NULL;
+        int ret;
+
+        ret = ff_inlink_consume_frame(inlink, &frame);
+        if (ret < 0)
+            return ret;
+        if (ret > 0)
+            return ff_filter_frame(outlink, frame);
+    }
+
+    FF_FILTER_FORWARD_STATUS(inlink, outlink);
+    FF_FILTER_FORWARD_WANTED(outlink, inlink);
+
+    return FFERROR_NOT_READY;
+}
+
+static av_cold void uninit(AVFilterContext *ctx)
+{
+    LatencyContext *s = ctx->priv;
+
+    if (s->min_latency != INT64_MAX)
+        av_log(ctx, AV_LOG_INFO, "Min latency: %"PRId64"\n", s->min_latency);
+    if (s->max_latency != INT64_MIN)
+        av_log(ctx, AV_LOG_INFO, "Max latency: %"PRId64"\n", s->max_latency);
+}
+
+#if CONFIG_LATENCY_FILTER
+
+AVFILTER_DEFINE_CLASS(latency);
+
+static const AVFilterPad latency_inputs[] = {
+    {
+        .name = "default",
+        .type = AVMEDIA_TYPE_VIDEO,
+    },
+};
+
+static const AVFilterPad latency_outputs[] = {
+    {
+        .name = "default",
+        .type = AVMEDIA_TYPE_VIDEO,
+    },
+};
+
+const AVFilter ff_vf_latency = {
+    .name          = "latency",
+    .description   = NULL_IF_CONFIG_SMALL("Report video filtering latency."),
+    .priv_size     = sizeof(LatencyContext),
+    .priv_class    = &latency_class,
+    .init          = init,
+    .uninit        = uninit,
+    .activate      = activate,
+    .flags         = AVFILTER_FLAG_SUPPORT_TIMELINE,
+    FILTER_INPUTS(latency_inputs),
+    FILTER_OUTPUTS(latency_outputs),
+};
+
+#endif // CONFIG_LATENCY_FILTER
+
+#if CONFIG_ALATENCY_FILTER
+
+#define alatency_options latency_options
+AVFILTER_DEFINE_CLASS(alatency);
+
+static const AVFilterPad alatency_inputs[] = {
+    {
+        .name = "default",
+        .type = AVMEDIA_TYPE_AUDIO,
+    },
+};
+
+static const AVFilterPad alatency_outputs[] = {
+    {
+        .name = "default",
+        .type = AVMEDIA_TYPE_AUDIO,
+    },
+};
+
+const AVFilter ff_af_alatency = {
+    .name          = "alatency",
+    .description   = NULL_IF_CONFIG_SMALL("Report audio filtering latency."),
+    .priv_size     = sizeof(LatencyContext),
+    .priv_class    = &alatency_class,
+    .init          = init,
+    .uninit        = uninit,
+    .activate      = activate,
+    .flags         = AVFILTER_FLAG_SUPPORT_TIMELINE,
+    FILTER_INPUTS(alatency_inputs),
+    FILTER_OUTPUTS(alatency_outputs),
+};
+#endif // CONFIG_ALATENCY_FILTER